Option Compare Database
Option Explicit

Public varCopyFromRow As Variant  ' Variant used to store the copy row's bookmark
Public varEmpty As Variant        ' An empty variant used to assign empty to varCopyFromRow
Public bCopyForward As Boolean    ' Set this to True to enable copying forward

Private Sub Form_Current()
'
' This function copies forward data from the previous row if bCopyForward is set
' to true
Dim rstFormRecordSet As Recordset, rstCopyRecordSet As Recordset, ctlControl As Control
On Error GoTo Form_Current_Exit                  ' Set up the error handler
'
' If this is a new record and copy forward is enabled then either duplicate the
' previously entered values or the values in the row bookmarked in varCopyFromRow
If Me.NewRecord And bCopyForward Then
   Set rstFormRecordSet = Me.RecordsetClone      ' Get access to the form's recordset
   Set rstCopyRecordSet = rstFormRecordSet.Clone ' Clone the form's recordset
   '
   ' If varCopyFromRow has a bookmark value it indicates the row to copy from,
   ' otherwise we copy from the last row in the recordset.
   If rstCopyRecordSet.Bookmarkable And Not IsEmpty(varCopyFromRow) Then
      rstCopyRecordSet.Bookmark = varCopyFromRow ' Get access to the copy from row
   Else                                          ' Otherwise
      rstCopyRecordSet.MoveLast                  ' Copy from the last row
   End If
   On Error Resume Next                          ' Ignore errors in this section
   '
   ' Note that this copies only data referenced in the form's bound controls. If
   ' there is row data (fields) not bound to controls on the form, it is not copied.
   ' Thus we are "filling in a form", not "copying a record".
   For Each ctlControl In Me.Controls            ' For each control on the form
      ' The fields named here are those we do not want to copy forward
      If ctlControl.Name <> "EmployeeID" And _
         ctlControl.Name <> "Photo" Then
         ctlControl = rstCopyRecordSet(ctlControl.ControlSource)
      End If
   Next
   On Error GoTo Form_Current_Exit               ' Restore the error handler
   varCopyFromRow = varEmpty                     ' Clear the copy-from row bookmark
   rstCopyRecordSet.Close                        ' Perform appropriate clean up chores
   rstFormRecordSet.Close                        '
   Me!FirstName.SetFocus                         ' Set focus to the first control
Else                                             '
   If Me.NewRecord Then                          '
      Me!FirstName.SetFocus                      '
   Else                                          '
      If Not IsEmpty(Me.Bookmark) Then           ' If there is a bookmark we can copy
         varCopyFromRow = Me.Bookmark            ' Make this the copy-from row
      End If
   End If
End If
Form_Current_Exit:
End Sub

