unit Main;

{
  Microsoft Agent Sample Application
  (c)1998 John Lam
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AgentObjects_TLB, StdCtrls;

type
  TForm1 = class(TForm)
    Agent1: TAgent;
    btnGo: TButton;
    procedure btnGoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FRobby: IAgentCtlCharacter;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnGoClick(Sender: TObject);
begin
  with FRobby do
  begin
    Show( False );    // the false argument (default) shows the entrance animation
    Play( 'Greet' );  // wave to the nice people ...

    // need to translate from form-based coordinates to screen-based coordinates
    MoveTo( Form1.Left + btnGo.Left + btnGo.Width, // Coordinates for top-left
            Form1.Top + btnGo.Top + btnGo.Height,  // corner
            1000 );                                // animation delay (ms)
    Play( 'GestureRight' );

    // the text can be inline (as below), or can be referred to by a URL (second arg)
    Speak( 'Click on this button, dude!', '' );
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // load and obtain a reference to Robby the Robot. An assumption here is that
  // the file resides locally on the user's hard drive. This is not an
  // unreasonable assumption for most agent applications since the robby.acs
  // file is a large (3MB+) file.
  with Agent1 do
  begin
    Characters.Load( 'robby', 'c:\agent\bin\robby.acs' );

    // strange ... this is spec'd as a default member of the IAgentCtlCharacters
    // dual interface. the type lib import utility should be converting this
    // into a default array property of the interface. e.g. Characters[ 'robby' ]
    // should allow indexing into the array ... but that does not compile
    FRobby := Characters.Item[ 'robby' ];
  end;
end;

end.
