import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import agentctl.IAgentCtlCharacter;

// The optional arguments passed to the Agent control API are all in the form
// of variants. We need to import this package to retrieve a reference to the 
// Variant helper class.
import com.ms.com.Variant;

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	private IAgentCtlCharacter m_Robby;
	
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// Retrieve a reference to the Robby character from a local file on
		// the user's hard drive. The syntactical differences between the Java
		// implementation here and the Visual Basic implementation has to do
		// with the mechanisms that are used to import ActiveX controls into
		// the Java runtime environment.
		agent1.getCharacters().Load( "robby", new Variant( "c:\\agent\\bin\\robby.acs" ) );		
		m_Robby = agent1.getCharacters().Character( "robby" );
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	private void btnGo_click(Object source, Event e)
	{
		// Show Robby as well as his entrance animation
		m_Robby.Show( new Variant( false ) );
		m_Robby.Play( "Wave" );		// wave to the nice people ...
		
		// Convert button coordinates to screen coordinates. Note the requirement
		// for an explicit narrowing of scope from int (32-bit) to short (16-bit)
		short x = (short)( this.getLocation().x + btnGo.getLocation().x + btnGo.getWidth() );
		short y = (short)( this.getLocation().x + btnGo.getLocation().y );
		
		m_Robby.MoveTo( x, y, new Variant( 1000 ) );
		m_Robby.Play( "GestureRight" );
		
		m_Robby.Speak( new Variant( "Click on this button, dude!" ), new Variant() );
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Button btnGo = new Button();
	agentctl.Agent.Agent agent1 = new agentctl.Agent.Agent();

	private void initForm()
	{
		// NOTE:  This form is storing resource information in an
		// external file.  Do not modify the string parameter to any
		// resources.getObject() function call.  For example, do not
		// modify "foo1_location" in the following line of code
		// even if the name of the Foo object changes: 
		//	 foo1.setLocation((Point)resources.getObject("foo1_location"));

		IResourceManager resources = new ResourceManager(this, "Form1");
		this.setText("Java Agent Demo");
		this.setAutoScaleBaseSize(16);
		this.setClientSize(new Point(319, 158));

		components.add(btnGo, "btnGo");
		btnGo.setLocation(new Point(128, 40));
		btnGo.setSize(new Point(80, 32));
		btnGo.setTabIndex(0);
		btnGo.setText("Go");
		btnGo.addOnClick(new EventHandler(this.btnGo_click));

		components.add(agent1, "agent1");
		agent1.setLocation(new Point(8, 8));
		agent1.setSize(new Point(32, 32));
		agent1.setTabIndex(1);
		agent1.setOcxState((AxHost.State)resources.getObject("agent1_ocxState"));

		this.setNewControls(new Control[] {
							agent1, 
							btnGo});

		agent1.begin();
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
